/********************************************************************************
	 -- Halo Map Scripted Objects
    Copyright  2011 Jesus7Freak

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*********************************************************************************
	File:    hmthread.cpp
	Project: Halo Map Scripted Objects
	Author:  Jesus7Freak
	Date:    10/29/2011
	Game:    Halo and Halo Custom Edition
	Version: all
*********************************************************************************/
#include "winmain.h"

char map_str[24] = {0};
   
wchar_t *main_module_name = NULL;
tagPROCESSENTRY32W pHalo = {0};

DWORD WINAPI HMThread(LPVOID lpMainWin)
{
   HWND hMainWin = (HWND)lpMainWin;
   
   //thread vars should be a little faster than static
   bool control_enabled_change = false,
      update_list = false;
      
   ULONG_PTR base_address = NULL;
   
   while (!exiting)
   {
      HWND hHaloWin = FindWindowW(L"Halo", L"Halo");
      if (hHaloWin)
      {
         DWORD dwProcessId;
         GetWindowThreadProcessId(hHaloWin, &dwProcessId);
         pHalo = RWMemory::GetProcessByID_W(dwProcessId);
         
         if (str_cmpW(pHalo.szExeFile, szHaloPC_exe))
         {
            running_gt = Halo;
            main_module_name = szHaloPC_exe;
            SetNewWindowText(GetDlgItem(hMainWin, IDC_HALO_TYPE), szHaloPC);
         }
         else if (str_cmpW(pHalo.szExeFile, szHaloCE_exe))
         {
            running_gt = HCE;
            main_module_name = szHaloCE_exe;
            SetNewWindowText(GetDlgItem(hMainWin, IDC_HALO_TYPE), szHaloCE);
         }
      }
      else
      {
         if (Halo_Process)
         {
            running_gt = not_running;
            halo_loaded = false;
            
            SetWindowText(GetDlgItem(hMainWin, IDC_HALO_TYPE), szHaloCE);
            SetWindowText(GetDlgItem(hMainWin, IDC_HALO_STATUS), szOff);
            
            main_module_name = empty_str;
            SetWindowText(GetDlgItem(hMainWin, IDC_MAP_LBL), empty_str);
            SetWindowTextA(GetDlgItem(hMainWin, IDC_MAP_STATUS), "");
            
            base_address = NULL;
            scan_size = 0;

            Current_Map_address = NULL;
            MapInfo_ptr_address = NULL;
            ScriptObjTags_ptr_address = NULL;
            DestroyObj_func_address = NULL;
            Object_ptr_address = NULL;
            CreateScriptedObj_func_address = NULL;
            map_str[0] = 0;
            
            HWND hItem_lstbx = GetDlgItem(hMainWin, IDC_ITEM_LSTBX);
            ListBox_ResetContent(hItem_lstbx);
            
            //destroy object txtbx
            EnableWindow(GetDlgItem(hMainWin, IDC_DEST_OBJ_BTN), FALSE);
            //create object txtbx
            EnableWindow(GetDlgItem(hMainWin, IDC_CRET_OBJ_BTN), FALSE);
            
            control_enabled_change = true;
            
            delete Halo_Process;
            Halo_Process = NULL;
         }
      }
      
      if (running_gt != not_running)
      {
         if (!Halo_Process)
         {
            Halo_Process = new RWMemory(pHalo.th32ProcessID);
            SetNewWindowText(GetDlgItem(hMainWin, IDC_MAP_LBL), szMap);
            SetNewWindowText(GetDlgItem(hMainWin, IDC_HALO_STATUS), szOn);
            
            if (Halo_Process->LastWin32Error == ERROR_ACCESS_DENIED)
            {
               ::MessageBoxW(
                  hMainWin, 
                  L"This App needs to be run as administrator", 
                  L"Error", 
                  MB_OK | MB_ICONWARNING | MB_TASKMODAL
                  );
                  
               SendMessage(hMainWin, WM_DESTROY, 0, 0);
            }
         
            //find halo module info
            if (!base_address)
               Halo_Process->ModuleSectionAddr_Size(
                  Halo_Process->GetProcessModuleByNameW(main_module_name).hModule, 
                  base_address, 
                  scan_size, 
                  (BYTE*)".text\0\0", 
                  false);
               
            //find patterns
            ULONG_PTR CMA_ptr = Halo_Process->FindMemPattern(
               base_address,
               scan_size,
               (BYTE*)"\x7F\x1F\xB8\x00\x00\x00\x00\x8D\x50",
               "x?x????xx");
               //HaloCE_lib::Current_map_addr_sig);
            
            if (CMA_ptr) CMA_ptr += 3;
            Current_Map_address = Halo_Process->ReadMem<DWORD>((LPVOID)CMA_ptr);


            ULONG_PTR MI_ptr = Halo_Process->FindMemPattern(
               base_address,
               scan_size,
               (BYTE*)"\xA1\x00\x00\x00\x00\x8B\x90\x08\x02\x00\x00",
               "x????xxxxxx");
               //HaloCE_lib::CreateScriptedObj_func_addr_sig);
            
            CreateScriptedObj_func_address = MI_ptr;
            MapInfo_ptr_address = Halo_Process->ReadMem<DWORD>((LPVOID)(MI_ptr + 1));


            ULONG_PTR SOT_ptr = Halo_Process->FindMemPattern(
               base_address,
               scan_size,
               (BYTE*)"\x7D\x09\x8B\x35\x00\x00\x00\x00\x89\x0C\x86",
               "xxxx????xxx");
               //HaloCE_lib::scripted_objtags_ptr_addr_sig);
            
            if (SOT_ptr) SOT_ptr += 4;  
            ScriptObjTags_ptr_address = Halo_Process->ReadMem<DWORD>((LPVOID)SOT_ptr);


            ULONG_PTR DOf_ptr = Halo_Process->FindMemPattern(
               base_address,
               scan_size,
               (BYTE*)"\x8B\x0D\x00\x00\x00\x00\x8B\x51\x34\x57",
               "xx????xxxx");
               //HaloCE_lib::DestroyObj_func_addr_sig);
                            
            DestroyObj_func_address = DOf_ptr;
            Object_ptr_address = Halo_Process->ReadMem<DWORD>((LPVOID)(DOf_ptr + 2));
            
            control_enabled_change = true;
         }
         
         Halo_Process->ReadMemString((LPVOID)Current_Map_address, map_str);
         
         HWND hMap = GetDlgItem(hMainWin, IDC_MAP_STATUS);
         GetWindowTextA(hMap, (LPSTR)BufferA, 32);
         //only change if its different
         if (!str_cmpA((char*)BufferA, (char*)map_str))
         {
            SetWindowTextA(hMap, map_str);
            update_list = true;
         }
         
         if (update_list)
         {
            DWORD iteminfo_ptr = Halo_Process->ReadMem<DWORD>((LPVOID)MapInfo_ptr_address);
            //this is NULL when theres no data or map is loading
            if (iteminfo_ptr)
            {
               int num_of_items = Halo_Process->ReadMem<int>((LPVOID)(iteminfo_ptr + 0x204));
               DWORD item_str_array = Halo_Process->ReadMem<DWORD>((LPVOID)(iteminfo_ptr + 0x208));
               
               HWND hItem_lstbx = GetDlgItem(hMainWin, IDC_ITEM_LSTBX);
               ListBox_ResetContent(hItem_lstbx);
               char *buffer_a = BufferA;
               for (int i = 0; i < num_of_items; i++)
               {
                  int _num = i, cnt = 0, pow = 1, j = 0;
    
                  do
                  { 
                     pow *= 10;/*to_base*/
                     cnt++;
                  }while(pow <= _num);

                  do
                  {
                     pow /= 10;//to_base;
                     buffer_a[j++] = (_num / pow) + 48;
                     _num %= pow;
                  }while(--cnt > 0);
                  
                  buffer_a[j++] = ' ';
                  Halo_Process->ReadMemArray<char>((LPVOID)(item_str_array + i*36), &buffer_a[j], 32);
                  SendMessageA(hItem_lstbx, LB_ADDSTRING, 0, (LPARAM)BufferA);
               }
               
               ListBox_SetCurSel(hItem_lstbx, 0);
               
               WPARAM wParam = (LBN_SELCHANGE << 16) + IDC_ITEM_LSTBX;
               SendMessageA(hMainWin, WM_COMMAND, wParam, (LPARAM)hItem_lstbx);
               
               update_list = false;
            }
         }
      }
      
      if (control_enabled_change)
      {
         //item lstbx
         EnableWindow(GetDlgItem(hMainWin, IDC_ITEM_LSTBX), running_gt != not_running);
         //item name txtbx
         EnableWindow(GetDlgItem(hMainWin, IDC_ITEM_NAME_TXTBX), running_gt != not_running);
         //item tag label
         EnableWindow(GetDlgItem(hMainWin, IDC_ITEM_TAG_LBL), running_gt != not_running);
         //item tag txtbx
         EnableWindow(GetDlgItem(hMainWin, IDC_ITEM_TAG_TXTBX), running_gt != not_running);
         //object address lbl
         EnableWindow(GetDlgItem(hMainWin, IDC_OBJ_ADDR_LBL), running_gt != not_running);
         //object address txtbx
         EnableWindow(GetDlgItem(hMainWin, IDC_OBJ_ADDR_TXTBX), running_gt != not_running);

         control_enabled_change = false;
      }
      
      for (int i = 0; i < 14 && !exiting; i++)
         Sleep(50);
   }
   
   return TRUE;
}

BOOL SetNewWindowText(HWND hWin, wchar_t *str)
{
   BOOL succeded = FALSE;
   GetWindowTextW(hWin, (LPWSTR)BufferW, 32);
   //only change if its different
   if (!str_cmpW((wchar_t*)BufferW, str))
   {
      succeded = SetWindowTextW(hWin, str);
   }
   return succeded;
}