/********************************************************************************
	 -- Halo Map Scripted Objects
    Copyright  2011 Jesus7Freak

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*********************************************************************************
	File:    winmain.cpp
	Project: Halo Map Scripted Objects
	Author:  Jesus7Freak
	Date:    10/29/2011
	Game:    Halo and Halo Custom Edition
	Version: all
*********************************************************************************/
#include "winmain.h"

RWMemory *Halo_Process = NULL;
bool exiting = false,
   halo_loaded = false;

char BufferA[32] = {0},
   *sInvalid = "Invalid";

wchar_t *szWindowClass = L"WinMain",
   *szTitle = L"Halo Map Scripted Objects  -  Jesus7Freak",
   *szHaloCE = L"Halo CE:",
   *szHaloPC = L"Halo PC:",
   *szHaloCE_exe = L"haloce.exe",
   *szHaloPC_exe = L"halo.exe",
   *szOn = L"On",
   *szOff = L"Off",
   *szMap = L"Map:",
   *empty_str = L"",
   *BufferW[32] = {0};
 
DWORD scan_size = 0,
   Current_Map_address = NULL,
   MapInfo_ptr_address = NULL,
   ScriptObjTags_ptr_address = NULL,
   DestroyObj_func_address = NULL,
   Object_ptr_address = NULL,
   CreateScriptedObj_func_address = NULL;
     
game_types running_gt = not_running;

HINSTANCE hInst;
HFONT hFont = NULL;

HMODULE hUxTheme = NULL;
BOOL (__stdcall *pIsAppThemed)();
HRESULT (__stdcall *pDrawThemeParentBackground)(HWND hwnd, HDC hdc, RECT *prc);

BOOL InitApp();
LRESULT CALLBACK WndMnProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);

//WndMnProc handlers
int OnCreate(HWND hwnd, LPCREATESTRUCT WinData);
void OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify);
//HBRUSH OnCtlColorStatic(HWND hwnd, HDC hdc, HWND hwndChild, int type);

int APIENTRY wWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
{
   //only run 1 instance
   //HANDLE lhMutex = CreateMutex(NULL, FALSE, L"Local\\Halo Dev Controls");
   //if (lhMutex && GetLastError () != ERROR_ALREADY_EXISTS) return 0;
   HWND hWin = FindWindowW(szWindowClass, szTitle);
   if (hWin)
   {
      SetForegroundWindow(hWin);
      return 0;
   }
   
   
   hInst = hInstance;
   if (!InitApp()) return 0;

   //Main Window
   HWND hMainWin = CreateWindowEx(
      WS_EX_WINDOWEDGE |
      WS_EX_CONTROLPARENT |
      WS_EX_APPWINDOW,
      szWindowClass,
      szTitle,
      WS_CAPTION |
      WS_SYSMENU,
      CW_USEDEFAULT, CW_USEDEFAULT,
      390, 250,
      NULL,
      NULL,
      hInstance,
      NULL
   );
   
   if (!hMainWin)
      return 2;
   
   
   hUxTheme = GetModuleHandle(L"uxtheme.dll");
   if (hUxTheme)
   {
      pIsAppThemed = (BOOL (__stdcall *)())GetProcAddress(hUxTheme, "IsAppThemed");
      pDrawThemeParentBackground = (HRESULT (__stdcall *)(HWND hwnd, HDC hdc, RECT *prc))GetProcAddress(hUxTheme, "DrawThemeParentBackground");
   }
   
   ShowWindow(hMainWin, nCmdShow);
   UpdateWindow(hMainWin);
   
   HANDLE hHMThread = CreateThread(NULL, 0, HMThread, (LPVOID)hMainWin, 0, NULL);
   
   // Main message loop:
   MSG msg;
   while (GetMessage(&msg, NULL, 0, 0))
   {
      TranslateMessage(&msg);
      DispatchMessage(&msg);
   }
   
   //tell HMThread to exit loop
   exiting = true;
   
   if (Halo_Process) delete Halo_Process;
   
   if (hHMThread)
   {
      WaitForSingleObject(hHMThread, 1000);
      CloseHandle(hHMThread);
   }
   
   return 7;//because I can
}

BOOL InitApp()
{
   //HBITMAP BmpBrush = LoadBitmapW(hInst, MAKEINTRESOURCE(IDB_MW_BG));
   //HBRUSH brPattern = CreatePatternBrush(BmpBrush);
   //DeleteObject(BmpBrush);
   
   WNDCLASSEX wcex;
   wcex.cbSize = sizeof(WNDCLASSEX);

   wcex.style          = CS_HREDRAW | CS_VREDRAW;
   wcex.lpfnWndProc    = WndMnProc;
   wcex.cbClsExtra     = 0;
   wcex.cbWndExtra     = 0;
   
   wcex.hInstance      = hInst;
   wcex.hIcon          = LoadIcon(hInst, MAKEINTRESOURCE(IDI_WINMAIN));
   wcex.hCursor        = LoadCursor(NULL, IDC_ARROW);
   wcex.hbrBackground  = GetStockBrush(LTGRAY_BRUSH );//brPattern;
   wcex.lpszMenuName   = NULL;
   wcex.lpszClassName  = szWindowClass;
   wcex.hIconSm        = NULL;
   
   if (!RegisterClassEx(&wcex)) return FALSE;
   
   INITCOMMONCONTROLSEX InitCtrlEx;
   InitCtrlEx.dwSize = sizeof(INITCOMMONCONTROLSEX);
	InitCtrlEx.dwICC  = ICC_STANDARD_CLASSES;
   InitCommonControlsEx(&InitCtrlEx); /* In case we use a common control */
      
   return TRUE;
}

LRESULT CALLBACK WndMnProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
   LRESULT ret_val = 0;

   switch (message)
   {
      case WM_CREATE:
         ret_val = HANDLE_WM_CREATE(hwnd, wParam, lParam, OnCreate);
         break;
         
      case WM_DESTROY:
         if (hFont) DeleteObject(hFont);
         PostQuitMessage(0);
         break;
         
      case WM_COMMAND:
         ret_val = HANDLE_WM_COMMAND(hwnd, wParam, lParam, OnCommand);
         break;
         
      /*case WM_CTLCOLORBTN:
         ret_val = (LRESULT)GetStockBrush(NULL_BRUSH);
         break;
         
      case WM_CTLCOLORSTATIC:
         ret_val = HANDLE_WM_CTLCOLORSTATIC(hwnd, wParam, lParam, OnCtlColorStatic);
         break;*/

      default:
         ret_val = DefWindowProc(hwnd, message, wParam, lParam);
         break;
   }

   return ret_val;
}

int OnCreate(HWND hwnd, LPCREATESTRUCT WinData)
{
   //(HFONT)::GetStockObject(DEFAULT_GUI_FONT);
   hFont = CreateFontW(
      16, 0, 
      0, 
      0,
      FW_NORMAL, 
      FALSE, 
      FALSE,
      FALSE, 
      DEFAULT_CHARSET, 
      OUT_DEFAULT_PRECIS, 
      CLIP_DEFAULT_PRECIS, 
      DEFAULT_QUALITY, 
      DEFAULT_PITCH, 
      L"Microsoft Sans Serif"
      );
      
      
   //halo type label
   HWND hHalo_Type = CreateWindowEx(
      NULL,
      L"STATIC",
      szHaloCE,
      WS_CHILD | 
      WS_VISIBLE |
      WS_CLIPSIBLINGS |
      WS_CLIPCHILDREN |
      SS_LEFT,
      2, 1,
      55, 16,
      hwnd,
      (HMENU)IDC_HALO_TYPE,
      WinData->hInstance,
      NULL
   );
   SetWindowFont(hHalo_Type, hFont, TRUE);
   
   //halo status label
   HWND hHalo_Status = CreateWindowEx(
      NULL,
      L"STATIC",
      szOff,
      WS_CHILD | 
      WS_VISIBLE |
      WS_CLIPSIBLINGS |
      WS_CLIPCHILDREN |
      SS_LEFT,
      57, 1,
      25, 16,
      hwnd,
      (HMENU)IDC_HALO_STATUS,
      WinData->hInstance,
      NULL
   );
   SetWindowFont(hHalo_Status, hFont, TRUE);
   
   //map label
   HWND hMap_lbl = CreateWindowEx(
      NULL,
      L"STATIC",
      NULL,
      WS_CHILD | 
      WS_VISIBLE |
      WS_CLIPSIBLINGS |
      WS_CLIPCHILDREN |
      SS_LEFT,
      81, 1,
      33, 16,
      hwnd,
      (HMENU)IDC_MAP_LBL,
      WinData->hInstance,
      NULL
   );
   SetWindowFont(hMap_lbl, hFont, TRUE);
   
   //map status label
   HWND hMap_Status = CreateWindowEx(
      NULL,
      L"STATIC",
      NULL,
      WS_CHILD | 
      WS_VISIBLE |
      WS_CLIPSIBLINGS |
      WS_CLIPCHILDREN |
      SS_LEFT,
      114, 1,
      269, 16,
      hwnd,
      (HMENU)IDC_MAP_STATUS,
      WinData->hInstance,
      NULL
   );
	SetWindowFont(hMap_Status, hFont, TRUE);
	
   //Script Item ListBx
   HWND hItemName_lstbx = CreateWindowEx(
      WS_EX_CLIENTEDGE,
      L"LISTBOX",
      NULL,
      WS_CHILD |
      WS_VISIBLE |
      WS_DISABLED |
      WS_CLIPSIBLINGS |
      WS_CLIPCHILDREN |
      WS_VSCROLL |
      WS_HSCROLL |
      LBS_NOTIFY,
      2, 20,
      150, 210,
      hwnd,
      (HMENU)IDC_ITEM_LSTBX,
      WinData->hInstance,
      NULL
   );
   SetWindowFont(hItemName_lstbx, hFont, TRUE);
   
   //Script Item Name textbox
   HWND hItemName_txtbx = CreateWindowEx(
      WS_EX_CLIENTEDGE,
      L"EDIT",
      NULL,
      WS_CHILD |
      WS_VISIBLE |
      WS_DISABLED |
      WS_CLIPSIBLINGS |
      WS_CLIPCHILDREN |
      ES_LEFT |
      ES_READONLY,
      155, 20,
      226, 20,
      hwnd,
      (HMENU)IDC_ITEM_NAME_TXTBX,
      WinData->hInstance,
      NULL
   );
   Edit_LimitText(hItemName_txtbx, 3);
   SetWindowFont(hItemName_txtbx, hFont, TRUE);
   
   //script item tag lbl
   HWND hItemTag_lbl = CreateWindowEx(
      NULL,
      L"STATIC",
      L"Object Tag",
      WS_CHILD | 
      WS_VISIBLE |
      WS_DISABLED |
      WS_CLIPSIBLINGS |
      WS_CLIPCHILDREN |
      SS_CENTER,
      155, 45,
      78, 18,
      hwnd,
      (HMENU)IDC_ITEM_TAG_LBL,
      WinData->hInstance,
      NULL
   );
   SetWindowFont(hItemTag_lbl, hFont, TRUE);
   
   //script item tag textbox
   HWND hItemTag_txtbx = CreateWindowEx(
      WS_EX_CLIENTEDGE,
      L"EDIT",
      NULL,
      WS_CHILD | 
      WS_VISIBLE |
      WS_DISABLED |
      WS_CLIPSIBLINGS |
      WS_CLIPCHILDREN |
      ES_LEFT |
      ES_READONLY,
      236, 44,
      86, 20,
      hwnd,
      (HMENU)IDC_ITEM_TAG_TXTBX,
      WinData->hInstance,
      NULL
   );
   Edit_LimitText(hItemTag_txtbx, 3);
   SetWindowFont(hItemTag_txtbx, hFont, TRUE);
   
   //object address lbl
   HWND hObjAddr_lbl = CreateWindowEx(
      NULL,
      L"STATIC",
      L"Object Address",
      WS_CHILD | 
      WS_VISIBLE |
      WS_DISABLED |
      WS_CLIPSIBLINGS |
      WS_CLIPCHILDREN |
      SS_CENTER,
      155, 65,
      98, 18,
      hwnd,
      (HMENU)IDC_OBJ_ADDR_LBL,
      WinData->hInstance,
      NULL
   );
   SetWindowFont(hObjAddr_lbl, hFont, TRUE);
   
   //object address textbox
   HWND hObjAddr_txtbx = CreateWindowEx(
      WS_EX_CLIENTEDGE,
      L"EDIT",
      NULL,
      WS_CHILD | 
      WS_VISIBLE |
      WS_DISABLED |
      WS_CLIPSIBLINGS |
      WS_CLIPCHILDREN |
      ES_LEFT |
      ES_READONLY,
      256, 64,
      86, 20,
      hwnd,
      (HMENU)IDC_OBJ_ADDR_TXTBX,
      WinData->hInstance,
      NULL
   );
   Edit_LimitText(hObjAddr_txtbx, 3);
   SetWindowFont(hObjAddr_txtbx, hFont, TRUE);
   
   //destroy object Button
   HWND hDestObj_btn = CreateWindowEx(
      NULL,
      L"BUTTON",
      L"Destroy Object",
      WS_CHILD | 
      WS_VISIBLE |
      WS_DISABLED |
      WS_CLIPSIBLINGS |
      WS_CLIPCHILDREN |
      BS_PUSHBUTTON, 
      155, 90,
      98, 25,
      hwnd,
      (HMENU)IDC_DEST_OBJ_BTN,
      WinData->hInstance,
      NULL
   );
   SetWindowFont(hDestObj_btn, hFont, TRUE);

   //create object Button
   HWND hCretObj_btn = CreateWindowEx(
      NULL,
      L"BUTTON",
      L"Create Object",
      WS_CHILD | 
      WS_VISIBLE |
      WS_DISABLED |
      WS_CLIPSIBLINGS |
      WS_CLIPCHILDREN |
      BS_PUSHBUTTON, 
      256, 90,
      90, 25,
      hwnd,
      (HMENU)IDC_CRET_OBJ_BTN,
      WinData->hInstance,
      NULL
   );
   SetWindowFont(hCretObj_btn, hFont, TRUE);
   
   return TRUE;
}

void OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)
{
   switch (codeNotify)
   {
      case BN_CLICKED:
         switch(id)
         {
            case IDC_DEST_OBJ_BTN:
            {
               int selected_index = ListBox_GetCurSel(GetDlgItem(hwnd, IDC_ITEM_LSTBX));
               DWORD itemtag_ptr = Halo_Process->ReadMem<DWORD>((LPVOID)ScriptObjTags_ptr_address);
               int ItemTag = Halo_Process->ReadMem<int>((LPVOID)(itemtag_ptr + selected_index*4));
                  
               if (DestroyObj_func_address)
               {
                  int asm_func_size = 10;
                  BYTE *asm_func = new BYTE[asm_func_size];
                  DWORD asm_func_loc = (DWORD)Halo_Process->AllocateMemory(asm_func_size);
                  
                  int byte_loc = 0;
                  asm_func[byte_loc++] = 0x8B;
                  asm_func[byte_loc++] = 0x44;
                  asm_func[byte_loc++] = 0x24;
                  asm_func[byte_loc++] = 0x04;      //mov eax,dword ptr [esp+4]
                  
                  asm_func[byte_loc++] = 0xE8;      //call DestroyObj_func_address
                  TO_BYTES(DWORD, &asm_func[byte_loc], DestroyObj_func_address - (asm_func_loc + byte_loc + 4));
                  byte_loc += sizeof(DWORD);
                  
                  asm_func[byte_loc++] = 0xC3;      //retn
                  
                  //write the function to allocated space
                  Halo_Process->WriteMemArray<BYTE>((LPVOID)asm_func_loc, asm_func, asm_func_size);

                  HANDLE NewThreadhnd = CreateRemoteThread(
                     Halo_Process->GetProcessHandle(),
                     NULL,
                     0,
                     (LPTHREAD_START_ROUTINE)asm_func_loc,
                     (LPVOID)ItemTag, 
                     0,
                     NULL
                     );
                     
                  if (NewThreadhnd)
                  {         
                     WaitForSingleObject(NewThreadhnd, 1000);
                     CloseHandle(NewThreadhnd);
                     
                     UpdateObjectInfo(hwnd, selected_index);
                  }
                  else
                     DWORD doslasterror = GetLastError();
                     
                  Halo_Process->FreeMemory((LPVOID)asm_func_loc);
                  delete[] asm_func;
               }
               break;
            }
            case IDC_CRET_OBJ_BTN:
            {
               int selected_index = ListBox_GetCurSel(GetDlgItem(hwnd, IDC_ITEM_LSTBX));

               if (CreateScriptedObj_func_address)
               {
                  int asm_func_size = 10;
                  BYTE *asm_func = new BYTE[asm_func_size];
                  DWORD asm_func_loc = (DWORD)Halo_Process->AllocateMemory(asm_func_size);
                  
                  int byte_loc = 0;
                  asm_func[byte_loc++] = 0x8B;
                  asm_func[byte_loc++] = 0x4C;
                  asm_func[byte_loc++] = 0x24;
                  asm_func[byte_loc++] = 0x04;      //mov ecx,dword ptr [esp+4]
                  
                  asm_func[byte_loc++] = 0xE8;      //call CreateScriptedObj_func_address
                  TO_BYTES(DWORD, &asm_func[byte_loc], CreateScriptedObj_func_address - (asm_func_loc + byte_loc + 4));
                  byte_loc += sizeof(DWORD);
                  
                  asm_func[byte_loc++] = 0xC3;      //retn
                  
                  //write the function to allocated space
                  Halo_Process->WriteMemArray<BYTE>((LPVOID)asm_func_loc, asm_func, asm_func_size);

                  HANDLE NewThreadhnd = CreateRemoteThread(
                     Halo_Process->GetProcessHandle(),
                     NULL,
                     0,
                     (LPTHREAD_START_ROUTINE)asm_func_loc,
                     (LPVOID)selected_index, 
                     0,
                     NULL
                     );
                     
                  if (NewThreadhnd)
                  {         
                     WaitForSingleObject(NewThreadhnd, 1000);
                     CloseHandle(NewThreadhnd);
                     
                     UpdateObjectInfo(hwnd, selected_index);
                  }
                  else
                     DWORD doslasterror = GetLastError();
               
                  Halo_Process->FreeMemory((LPVOID)asm_func_loc);
                  delete[] asm_func;
               }
               break;
            }
         }
      
      case LBN_SELCHANGE:
         switch (id)
         {
            case IDC_ITEM_LSTBX:
               UpdateObjectInfo(hwnd, ListBox_GetCurSel(hwndCtl));
               break;
         }
   }
}

void UpdateObjectInfo(HWND hwnd, int SelectedIndex)
{
   if (SelectedIndex != LB_ERR)
   {
      DWORD iteminfo_ptr = Halo_Process->ReadMem<DWORD>((LPVOID)MapInfo_ptr_address);
      DWORD item_str_array = Halo_Process->ReadMem<DWORD>((LPVOID)(iteminfo_ptr + 0x208));
      Halo_Process->ReadMemArray<char>((LPVOID)(item_str_array + SelectedIndex*36), BufferA, 32);
      
      SetWindowTextA(GetDlgItem(hwnd, IDC_ITEM_NAME_TXTBX), BufferA);
      
      BufferA[0] = '0';
      BufferA[1] = 'x';
      
      DWORD itemtag_ptr = Halo_Process->ReadMem<DWORD>((LPVOID)ScriptObjTags_ptr_address);
      int ItemTag = Halo_Process->ReadMem<int>((LPVOID)(itemtag_ptr + SelectedIndex*4));
      
      sprintf_s(&BufferA[2], HEXNUM_LENGTH, "%lX", ItemTag);
      SetWindowTextA(GetDlgItem(hwnd, IDC_ITEM_TAG_TXTBX), BufferA);
      
      if (ItemTag != -1)
      {
         DWORD obj_header = Halo_Process->ReadMem<DWORD>((LPVOID)Object_ptr_address);
         DWORD obj_array = Halo_Process->ReadMem<DWORD>((LPVOID)(obj_header + 0x34));
         DWORD obj_address = Halo_Process->ReadMem<DWORD>((LPVOID)(obj_array + ((short)ItemTag)*0xC + 8));
         
         sprintf_s(&BufferA[2], HEXNUM_LENGTH, "%lX", obj_address);
         SetWindowTextA(GetDlgItem(hwnd, IDC_OBJ_ADDR_TXTBX), BufferA);
      }
      else
         SetWindowTextA(GetDlgItem(hwnd, IDC_OBJ_ADDR_TXTBX), sInvalid);
         
      BOOL valid_tag = BOOL(ItemTag != -1);
      //destroy object txtbx
      EnableWindow(GetDlgItem(hwnd, IDC_DEST_OBJ_BTN), valid_tag && DestroyObj_func_address);
      EnableWindow(GetDlgItem(hwnd, IDC_CRET_OBJ_BTN), !valid_tag && CreateScriptedObj_func_address);
   }
   else
   {
      SetWindowTextA(GetDlgItem(hwnd, IDC_ITEM_NAME_TXTBX), "");
      SetWindowTextA(GetDlgItem(hwnd, IDC_ITEM_TAG_TXTBX), "");
      SetWindowTextA(GetDlgItem(hwnd, IDC_OBJ_ADDR_TXTBX), "");
   }
}